clear;
clc;
clearglobal;

D=0.0018;
J=0.00045;
k=0.015;
R=1.0;
L=0.003;

//r1 und r2 so whlen, das eine doppelte reelle Polstelle bei -10 entsteht:
doppelpolstelle = -20
r2 = (2*(-doppelpolstelle)-(D/J))*L-R
r1 = J*L*(1/k)*(-(D/J)*(R+r2)/L + 0.25*((R+r2)/L+D/J)^2)-k

//Stationre Werte fr i und omega bestimmen fr u=5Volt:
u = 5;
A = [-D/J,k/J;-k/L,-R/L];
b = [0;u/L]
y_stat = inv(A)*(-b);
w_stat = y_stat(1,1)
i_stat = y_stat(2,1)

//Systemmatrix:
AA = [[-D/J,k/J];[-k/L,-R/L]];

//Gewichtungsmatrix fr Zustandsgren:
QQ = [[1,0];[0,1]];

//Ausgangsmatrix:
CC = [[1,0];[0,1]];

//Durchgangsmatrix:
//DD = [[1,0];[0,1]];
DD = [0;0];

//Eingangsmatrix / Rckfhrungsmatrix
BB = [0;1/L];

//[X,RCOND,FERR] = riccsl(AA,CC,DD,'cont','schr')
GG = syslin('c',AA,BB,CC,DD);
[XX,FF] = gcare(GG);

XX

RR = BB'*XX

r1_ricc=RR(1,1);
r2_ricc=RR(1,2);

//ungeregelt:
function f = rechteSeite(t,y)
    u=5;
    B=[0;1/L]
    f=A*y+B*u;
endfunction


//-20 als doppelte Polstellen:
function f = rechteSeite3(t,y)
    u = -r1*(y(1,1)-w_stat)-r2*(y(2,1)-i_stat)+k*w_stat+R*i_stat;
    f(1,1)=(-D/J)*y(1,1)+(k/J)*y(2,1);
    f(1,2)=(-k/L)*y(1,1)+(-R/L)*y(2,1)+(1/L)*u;
endfunction

//Riccati-Lsung:
function f = rechteSeite4(t,y)
    u = -r1_ricc*(y(1,1)-w_stat)-r2_ricc*(y(2,1)-i_stat)+k*w_stat+R*i_stat;
    f(1,1)=(-D/J)*y(1,1)+(k/J)*y(2,1);
    f(1,2)=(-k/L)*y(1,1)+(-R/L)*y(2,1)+(1/L)*u;
endfunction


t = 0:0.01:1;
y0 = [0,0]';
yb0 = [0,0,0,0]';
ybb0 = [0,0,20,20]';
t0   = 0;
y    = ode(y0,t0,t,rechteSeite);
y3   = ode(y0,t0,t,rechteSeite3);
y4   = ode(y0,t0,t,rechteSeite4);
plot(t,y(1,:)','blu',t,y3(1,:)','gre',t,y4(1,:)','red');




